#property copyright "Integer"
#property link      "https://login.mql5.com/ru/users/integer"
#property version   "1.00"

#property strict
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 2
#property indicator_buffers 1
#property indicator_plots   1
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrMediumSeaGreen
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

/*
      Period1 ,   , 
      ,   ,  .
   
   :
   
      Period1 -   
   
*/

input int      Period1  =  20;

//--- indicator buffers
double         Label1Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(){
   SetIndexBuffer(0,Label1Buffer);
   SetIndexArrow(0,159);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   int limit=rates_total-prev_calculated;

   if(prev_calculated==0){
      limit--;
      limit-=Period1;
   }
   
   for(int i=limit;i>=0;i--){
   
      Label1Buffer[i]=Label1Buffer[i+1];
   
      int hb1=iHighest(NULL,0,MODE_HIGH,Period1,i);
      int lb1=iLowest(NULL,0,MODE_LOW,Period1,i);
      int hb2=iHighest(NULL,0,MODE_HIGH,Period1,i+1);
      int lb2=iLowest(NULL,0,MODE_LOW,Period1,i+1);

      double r1=High[hb1]-Low[lb1];
      double r2=High[hb2]-Low[lb2];
      
      if(r1>r2){
         Label1Buffer[i]=1;
      }
      else if(r1<r2){
         Label1Buffer[i]=EMPTY_VALUE;      
      }

   } 

   

   return(rates_total);
  }
//+------------------------------------------------------------------+
